Index: sys/kern/uipc_sockbuf.c
===================================================================
RCS file: /home/ncvs/src/sys/kern/uipc_sockbuf.c,v
retrieving revision 1.176
diff -u -r1.176 uipc_sockbuf.c
--- sys/kern/uipc_sockbuf.c	4 Feb 2008 12:25:13 -0000	1.176
+++ sys/kern/uipc_sockbuf.c	24 Apr 2008 07:20:33 -0000
@@ -1027,6 +1027,8 @@
 	xsb->sb_cc = sb->sb_cc;
 	xsb->sb_hiwat = sb->sb_hiwat;
 	xsb->sb_mbcnt = sb->sb_mbcnt;
+	xsb->sb_mcnt = sb->sb_mcnt;	
+	xsb->sb_ccnt = sb->sb_ccnt;
 	xsb->sb_mbmax = sb->sb_mbmax;
 	xsb->sb_lowat = sb->sb_lowat;
 	xsb->sb_flags = sb->sb_flags;
Index: sys/sys/socketvar.h
===================================================================
RCS file: /home/ncvs/src/sys/sys/socketvar.h,v
retrieving revision 1.162
diff -u -r1.162 socketvar.h
--- sys/sys/socketvar.h	4 Feb 2008 12:25:13 -0000	1.162
+++ sys/sys/socketvar.h	24 Apr 2008 07:20:44 -0000
@@ -110,6 +110,8 @@
 		u_int	sb_cc;		/* (c/d) actual chars in buffer */
 		u_int	sb_hiwat;	/* (c/d) max actual char count */
 		u_int	sb_mbcnt;	/* (c/d) chars of mbufs used */
+		u_int   sb_mcnt;        /* number of mbufs in buffer */
+		u_int   sb_ccnt;        /* number of clusters in buffer */
 		u_int	sb_mbmax;	/* (c/d) max chars of mbufs to use */
 		u_int	sb_ctl;		/* (c/d) non-data chars in buffer */
 		int	sb_lowat;	/* (c/d) low water mark */
@@ -258,6 +260,8 @@
 		u_int	sb_cc;
 		u_int	sb_hiwat;
 		u_int	sb_mbcnt;
+		u_int   sb_mcnt;
+		u_int   sb_ccnt;
 		u_int	sb_mbmax;
 		int	sb_lowat;
 		int	sb_timeo;
@@ -319,8 +323,11 @@
 	if ((m)->m_type != MT_DATA && (m)->m_type != MT_OOBDATA) \
 		(sb)->sb_ctl += (m)->m_len; \
 	(sb)->sb_mbcnt += MSIZE; \
-	if ((m)->m_flags & M_EXT) \
+	(sb)->sb_mcnt += 1; \
+	if ((m)->m_flags & M_EXT) { \
 		(sb)->sb_mbcnt += (m)->m_ext.ext_size; \
+		(sb)->sb_ccnt += 1; \
+	} \
 }
 
 /* adjust counters in sb reflecting freeing of m */
@@ -329,8 +336,11 @@
 	if ((m)->m_type != MT_DATA && (m)->m_type != MT_OOBDATA) \
 		(sb)->sb_ctl -= (m)->m_len; \
 	(sb)->sb_mbcnt -= MSIZE; \
-	if ((m)->m_flags & M_EXT) \
+	(sb)->sb_mcnt -= 1; \
+	if ((m)->m_flags & M_EXT) { \
 		(sb)->sb_mbcnt -= (m)->m_ext.ext_size; \
+		(sb)->sb_ccnt -= 1; \
+	} \
 	if ((sb)->sb_sndptr == (m)) { \
 		(sb)->sb_sndptr = NULL; \
 		(sb)->sb_sndptroff = 0; \
Index: usr.bin/netstat/inet.c
===================================================================
RCS file: /home/ncvs/src/usr.bin/netstat/inet.c,v
retrieving revision 1.82
diff -u -r1.82 inet.c
--- usr.bin/netstat/inet.c	4 Jan 2008 03:09:28 -0000	1.82
+++ usr.bin/netstat/inet.c	24 Apr 2008 07:20:57 -0000
@@ -142,6 +142,8 @@
 	xsb->sb_cc = sb->sb_cc;
 	xsb->sb_hiwat = sb->sb_hiwat;
 	xsb->sb_mbcnt = sb->sb_mbcnt;
+	xsb->sb_mcnt = sb->sb_mcnt;
+	xsb->sb_ccnt = sb->sb_ccnt;
 	xsb->sb_mbmax = sb->sb_mbmax;
 	xsb->sb_lowat = sb->sb_lowat;
 	xsb->sb_flags = sb->sb_flags;
@@ -407,9 +409,11 @@
 				    "Proto", "Listen", "Local Address");
 			else
 				printf((Aflag && !Wflag) ?
-		"%-5.5s %-6.6s %-6.6s  %-18.18s %-18.18s %s\n" :
-		"%-5.5s %-6.6s %-6.6s  %-22.22s %-22.22s %s\n",
+		"%-5.5s %-6.6s %-6.6s %-6.6s %-6.6s %-6.6s %-6.6s %-18.18s %-18.18s %s\n" :
+		"%-5.5s %-6.6s %-6.6s %-6.6s %-6.6s %-6.6s %-6.6s  %-22.22s %-22.22s %s\n",
 				    "Proto", "Recv-Q", "Send-Q",
+				    "Recv-M", "Send-M",
+				    "Recv-C", "Send-C",
 				    "Local Address", "Foreign Address",
 				    "(state)");
 			first = 0;
@@ -438,7 +442,10 @@
 			    so->so_incqlen, so->so_qlimit);
 			printf("%-14.14s ", buf1);
 		} else {
-			printf("%6u %6u  ", so->so_rcv.sb_cc, so->so_snd.sb_cc);
+			printf("%6u %6u %6u %6u %6u %6u  ", 
+			       so->so_rcv.sb_cc, so->so_snd.sb_cc, 
+			       so->so_rcv.sb_mcnt, so->so_snd.sb_mcnt,
+			       so->so_rcv.sb_ccnt, so->so_snd.sb_ccnt);
 		}
 		if (numeric_port) {
 			if (inp->inp_vflag & INP_IPV4) {
